VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHashing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Function CalcHashBuf(ByVal buf As String) As String
Dim pos As Long, sublen As Long
Dim hashbuf(&H10 + 5) As Long
hashbuf(0) = &H67452301
hashbuf(1) = &HEFCDAB89
hashbuf(2) = &H98BADCFE
hashbuf(3) = &H10325476
hashbuf(4) = &HC3D2E1F0
For pos = 0 To Len(buf) Step &H40
    sublen = Len(buf) - pos
    If sublen > &H40 Then sublen = &H40
    Dim t As String
    t = Mid$(buf, pos + 1, sublen) & String(&H40 - sublen, Chr$(0))
    Dim I As Long
    For I = 0 To 15
        hashbuf(5 + I) = Functions.GetDWORD(Mid$(t, I * 4 + 1, 4))
    Next I
    Call DataHash(hashbuf)
Next pos
CalcHashBuf = Functions.LongToStr(hashbuf(0)) & _
    Functions.LongToStr(hashbuf(1)) & _
    Functions.LongToStr(hashbuf(2)) & _
    Functions.LongToStr(hashbuf(3)) & _
    Functions.LongToStr(hashbuf(4))
End Function
Private Sub DataHash(ByRef param() As Long)
Dim buf(&H50) As Long
Dim A As Long, B As Long, C As Long, D As Long, E As Long, G As Long
Dim I As Long
Dim p As Long
p = UBound(param) - 5
If p > &H40 Then p = &H40
For I = 0 To p - 1
    buf(I) = param(I + 5)
Next
For I = &H10 To &H4F
    G = buf(I - &H10) Xor buf(I - &H8) Xor buf(I - &HE) Xor buf(I - &H3)
    buf(I) = Rol(1, G)
Next
A = param(0)
B = param(1)
C = param(2)
D = param(3)
E = param(4)
For I = 0 To 79
    G = buf(I)
    G = Add(G, E)
    G = Add(G, Rol(A, 5))
    Select Case I
        Case Is < 20
            G = Add(G, ((B And C) Or ((Not B) And D)))
            G = Add(G, &H5A827999)
        Case Is < 40
            G = Add(G, (D Xor C Xor B))
            G = Add(G, &H6ED9EBA1)
        Case Is < 60
            G = Add(G, (C And B) Or (D And C) Or (D And B))
            G = Add(G, &H8F1BBCDC)
        Case Is < 80
            G = Add(G, (D Xor C Xor B))
            G = Add(G, &HCA62C1D6)
        Case Else
            Exit Sub
    End Select
    E = D
    D = C
    C = Rol(B, 30)
    B = A
    A = G
Next
param(0) = Add(param(0), A)
param(1) = Add(param(1), B)
param(2) = Add(param(2), C)
param(3) = Add(param(3), D)
param(4) = Add(param(4), E)
End Sub
Private Function Add(ByVal number1 As Long, ByVal number2 As Long) As Long
Add = DtoL(CDbl(number1) + CDbl(number2))
End Function
Private Function DtoL(ByVal num As Double) As Long
While num > &H7FFFFFFF
    num = num - 4294967296#
Wend
While num < &H80000000
    num = num + 4294967296#
Wend
DtoL = CLng(num)
End Function
Private Function Rol(ByVal Number As Long, ByVal Shift As Long) As Long
Shift = Shift And &H1F
Rol = LShift(Number, Shift) Or RShift(Number, 32 - Shift)
End Function
Private Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Long
If pnShift > 31 Then
    LShift = 0
ElseIf pnShift < 0 Then
    LShift = 0
ElseIf pnShift = 0 Then
    LShift = pnValue
Else
    pnValue = pnValue And (2 ^ (32 - pnShift) - 1)
    LShift = DtoL(CDbl(pnValue) * CDbl(DtoL(2 ^ pnShift)))
End If
End Function
Private Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Long
If pnShift > 31 Then
    RShift = 0
ElseIf pnShift < 0 Then
    RShift = 0
ElseIf pnShift = 0 Then
    RShift = pnValue
Else
    If (pnValue And &H80000000) = &H80000000 Then
        RShift = (pnValue And &H7FFFFFFF)
        RShift = RShift \ (2 ^ pnShift)
        RShift = RShift Or (2 ^ (31 - pnShift))
    Else
        RShift = Int(CDbl(pnValue) / CDbl(2 ^ pnShift))
    End If
    If RShift = -1 Then Debug.Assert False
End If
End Function
